changed to /bin/bash
[grml-terminalserver.git] / linuxrc
diff --git a/linuxrc b/linuxrc
index 85ae3ef..86f67af 100755 (executable)
--- a/linuxrc
+++ b/linuxrc
@@ -2,7 +2,7 @@
 # Filename: /linuxrc
 # Purpose:  minirt for kernel 2.6 running on grml live-cd
 # Authors:  (c) Klaus Knopper <knoppix@knopper.net>, (c) Michael Prokop <mika@grml.org>
-# Latest change: Mon Sep 18 23:19:53 CEST 2006 [mika]
+# Latest change: Tue Mar 27 23:05:51 CEST 2007
 #######################################################################################
 
 # hardcoded configurable options
@@ -183,7 +183,7 @@ echo ""
 echo "${WHITE}grml.org - Linux for users of texttools and sysadmins."
 echo "${NORMAL}"
 
-# We only need the builtin commands and /static at this point
+# We need the builtin commands and /static only starting at this point
 PATH=/static
 export PATH
 
@@ -216,6 +216,10 @@ GRML_NAME="GRML"
 case "$CMDLINE" in *grml_dir=*) GRML_DIR="$grml_dir"; ;; esac
 case "$CMDLINE" in *grml_name=*) GRML_NAME="$grml_name"; ;; esac
 
+# NFS
+for i in $cmdline; do case "$i" in nfsdir=*|NFSDIR=*) eval $i;; esac; done
+[ -n "$nfsdir" ] && NFS="$nfsdir"
+
 if [ -n "$DEBUG" ]; then
    log_begin_msg "Bootoption debug detected. Printing kernel command line:"
    echo ""
@@ -269,7 +273,7 @@ askmodules(){
  c=""
  for m in "$@"; do
   if test -f "/modules/scsi/$m"; then
-   test -z "$c"  && { echo -n "        $m"; c="1"; } || { echo "               $m"; c=""; }
+   test -z "$c"  && { echo -n " $m"; c="1"; } || { echo "               $m"; c=""; }
   fi
  done
  [ -n "$c" ] && echo ""
@@ -287,7 +291,7 @@ loadmodules(){
  echo ""
  for i in "$@"; do
   echo -n "   Probing ${TYPE}... ${WHITE}$i${NORMAL}: "
-   if test -f /modules/scsi/$i.ko && $INSMOD -f /modules/scsi/$i.ko >/dev/null 2>&1 && echo "  $SUCCESS" || echo " failed " ; then
+   if test -f /modules/scsi/$i.ko && $INSMOD /modules/scsi/$i.ko >/dev/null 2>&1 && echo "  $SUCCESS" || echo " failed " ; then
      case "$TYPE" in scsi|SCSI) FOUND_SCSI="yes"; ;; esac
    fi
  done
@@ -350,7 +354,7 @@ fi
 
 if test -z "$NOSCSI" ; then
  log_begin_msg "Scanning for SCSI devices."
- $INSMOD -f /modules/scsi/firmware_class.ko 1>/dev/null
+ $INSMOD /modules/scsi/firmware_class.ko 1>/dev/null
  test -n "$MODULES" && loadmodules SCSI $MODULES &&  echo -n "" || echo "           ${BLUE}[${NORMAL} none found ${BLUE}]${NORMAL} (try bootoption scsi=probe)"
 else
   log_warn_msg "Not scanning for SCSI devices as requested on commandline." && echo " $SUCCESS"
@@ -361,10 +365,10 @@ if checkbootparam scsi ; then
   if test "$MODULE" = "probe" ; then
     log_begin_msg "Bootoption scsi=probe found. Trying to autoprobe SCSI modules:"
     echo ""
-    echo -n "   Trying to load scsi_debug: " ; $INSMOD -f /modules/scsi/scsi_debug.ko 1>/dev/null && echo "           $SUCCESS" || echo " [ failed ]"
+    echo -n "   Trying to load scsi_debug: " ; $INSMOD /modules/scsi/scsi_debug.ko 1>/dev/null && echo "           $SUCCESS" || echo " [ failed ]"
     for module in /modules/scsi/*.ko ; do
       echo -n "   Probing ${WHITE}${module}${NORMAL}..."
-      $INSMOD -f ${module} >/dev/null 2>&1 && echo " $SUCCESS" || echo " [ failed ]"
+      $INSMOD ${module} >/dev/null 2>&1 && echo " $SUCCESS" || echo " [ failed ]"
     done
   elif test "$MODULE" = "ask" ; then
     askmodules SCSI $(cd /modules/scsi; echo *.ko)
@@ -372,7 +376,7 @@ if checkbootparam scsi ; then
   else
     [ -n "$MODULE" ] || echo "   ${RED}Neither a specific module nor option probe nor option ask for SCSI module given. Skipping.${NORMAL}"
     [ -n "$MODULE" ] && echo -n "   Trying to load module ${WHITE}${MODULE}${NORMAL}:" ; \
-      $INSMOD -f "/modules/scsi/${MODULE}.ko" 1>/dev/null && echo "  $SUCCESS" || echo " [ failed ]"
+      $INSMOD "/modules/scsi/${MODULE}.ko" 1>/dev/null && echo "  $SUCCESS" || echo " [ failed ]"
   fi
 fi
 # End of SCSI check
@@ -382,7 +386,7 @@ if test -n "$VMWARE" ; then
   echo ""
   for module in mptbase mptscsih mptspi BusLogic ; do
     echo -n "   Trying to load ${WHITE}${module}${NORMAL}: "
-    $INSMOD -f /modules/scsi/${module}.ko >/dev/null 2>&1 && echo " $SUCCESS" || echo " [ failed ]"
+    $INSMOD /modules/scsi/${module}.ko >/dev/null 2>&1 && echo " $SUCCESS" || echo " [ failed ]"
   done
 fi
 
@@ -392,7 +396,7 @@ if test -z "$NOUSB"; then
   if test -f /modules/div/usbcore.ko; then
     $INSMOD /modules/div/usbcore.ko >/dev/null 2>&1
     FOUNDUSB=""
-    for i in $USB2 uhci-hcd.ko ohci-hcd.ko ; do
+    for i in $USB2 uhci-hcd.ko ohci-hcd.ko usbhid.ko ; do
       test -f /modules/div/$i && $INSMOD /modules/div/$i >/dev/null 2>&1 && FOUNDUSB="yes"
     done
     if test -n "$FOUNDUSB"; then
@@ -419,7 +423,7 @@ fi
 if test -z "$NOFIREWIRE" ; then
   log_begin_msg "Checking for Firewire."
   if test -f /modules/div/ieee1394.ko ; then
-    $insmoD /modules/div/ieee1394.ko > /dev/null 2>&1
+    $INSMOD /modules/div/ieee1394.ko > /dev/null 2>&1
     FOUNDFIREWIRE=""
     test -f /modules/div/ohci1394.ko && $INSMOD /modules/div/ohci1394.ko > /dev/null 2>&1 && FOUNDFIREWIRE="yes"
     if test -n "$FOUNDFIREWIRE" ; then
@@ -458,11 +462,11 @@ fi
 # boot via pcmcia
 if checkbootparam bootpcmcia ; then
   log_begin_msg "Bootoption bootpcmcia found. Trying to load ${WHITE}PCMCIA${NORMAL} modules..."
-  if $INSMOD -f /modules/div/pcmcia_core.ko 1>/dev/null ; then
-     $INSMOD -f /modules/div/firmware_class.ko 1>/dev/null && \
-     $INSMOD -f /modules/div/pcmcia.ko         1>/dev/null && \
-     $INSMOD -f /modules/div/rsrc_nonstatic.ko 1>/dev/null && \
-     $INSMOD -f /modules/div/yenta_socket.ko   1>/dev/null && echo " $SUCCESS"
+  if $INSMOD /modules/div/pcmcia_core.ko 1>/dev/null ; then
+     $INSMOD /modules/div/firmware_class.ko 1>/dev/null && \
+     $INSMOD /modules/div/pcmcia.ko         1>/dev/null && \
+     $INSMOD /modules/div/rsrc_nonstatic.ko 1>/dev/null && \
+     $INSMOD /modules/div/yenta_socket.ko   1>/dev/null && echo " $SUCCESS"
   else
     echo " [ failed ]"
   fi
@@ -508,25 +512,61 @@ esac
 
 stage=2
 rundebugshell
-# NFS
-if checkbootparam "nfsdir" ; then
-  NFS="$(getbootparam nfsdir)"
-#  if test -z $NFS
-#    then
-#    NFS=192.168.0.1
-#    echo "${CRE}${BLUE}No NFS-server given, assuming default $NFS${NORMAL}"
-#  fi
-  echo "${RED}Debug: NFS = ${NFS}${NORMAL}"
-  log_begin_msg "${CRE} ${GREEN}*${NORMAL} Looking for CD-ROM in: ${MAGENTA}$NFS${NORMAL}"
-  if mountit -t nfs $NFS "-o ro" >/dev/null 2>&1
+if [ -n "$NFS" ]; then
+  tmp_="$(getbootparam nfsdir)"
+  log_begin_msg "Bootoption NFS found." ; echo "$SUCCESS"
+
+  /static/cdir
+
+  log_begin_msg "Trying to load network driver(s)." ; echo
+  modLoad()
+  {
+    for mod in $@ ; do
+      if [ -n "$DEBUG" ] ; then
+         echo "Debug: trying to load $mod:"
+         modprobe -v $mod
+      else
+         modprobe $mod 2>/dev/null
+      fi
+    done
+  }
+  # modules.alias and modules.dep are in place so USE IT :)!
+  find /sys/devices/ -name modalias |/static/xargs -r /static/grep -h pci: |while read i; do
+    modLoad "$i"
+  done
+  # loading additional modules
+  modLoad sunrpc lockd af_packet nfs
+
+  dhcp_iface_=$(getbootparam dhcp_iface)
+  if [ -z "$dhcp_iface_" ]; then
+       dhcp_iface_=`ifconfig -a | grep '^eth' | sed 's/ .*//'`
+  fi
+
+  # make sure we have a udhcpc executable, if it's not present
+  # assume that busybox provides one
+  if ! [ -x /static/udhcpc ] ; then
+     ln -s /static/busybox /static/udhcpc
+  fi
+
+  for INTERFACE in $dhcp_iface_ ; do
+      log_begin_msg "Requesting network configuration using udhcp for ${INTERFACE}:" ; echo
+      /static/timeout 10 /static/udhcpc --interface="${INTERFACE}" --foreground --quit --script=/static/udhcp-config.sh
+      # echo "press <enter> to start a system shell and configure your system"
+      # sh
+  done
+
+  # recreate dir layout + remove extra modules
+  /static/rdir
+
+  log_begin_msg "Looking for GRML in: ${MAGENTA}$NFS${NORMAL}" ; echo "$SUCCESS"
+  if mount -t nfs "$NFS" -o "async,ro,nolock" /cdrom #>/dev/null 2>&1
     then
     if test -f /cdrom/$GRML_DIR/$GRML_NAME
       then
-      log_begin_msg "Accessing grml CD-ROM at ${MAGENTA}${NFS}${NORMAL}" ; echo "     $SUCCESS"
+      log_begin_msg "Accessing grml CDROM at ${MAGENTA}$NFS${NORMAL}" ; echo "$SUCCESS"
       FOUND_GRML="$NFS"
       break
     fi
-    umount /cdrom
   fi
 fi
 
@@ -576,7 +616,7 @@ remount_grml()
     [ -n "$SOURCE2" ] && umount $SOURCE2  # umount possible loop-device
     mount_grml $TARGET
   else
-    echo "${CRE} ${RED}Warning: Changing to $TARGET failed.${NORMAL}"
+    log_failure_msg "Warning: Changing to $TARGET failed."
     return 1
   fi
 
@@ -598,7 +638,7 @@ boot_from()
   # load filesystems
   /GRML/sbin/modprobe fuse
   /GRML/sbin/modprobe ntfs
-  $INSMOD -f /modules/div/ntfs.ko 1>/dev/null
+  $INSMOD /modules/div/ntfs.ko 1>/dev/null
 
   if [ -n "$ISO_PATH" ]; then
      LOOP_SOURCE="$TARGET.loop"
@@ -613,7 +653,7 @@ boot_from()
   fi
   if [ $? -ne 0 ]; then
      [ -n "$LOOP_SOURCE" ] && /bin/umount $LOOP_SOURCE
-     echo -n "${CRE} ${RED}Accessing grml CD-ROM failed. ${MAGENTA}$TARGET_DEV${RED} is not mountable.${NORMAL}"
+     log_failure_msg "Accessing grml CD-ROM failed. ${MAGENTA}$TARGET_DEV${NORMAL} is not mountable."
      sleep 2
      return 1
   fi
@@ -621,7 +661,7 @@ boot_from()
   if [ -f $TARGET/$GRML_DIR/$GRML_NAME ]; then
     log_begin_msg "Accessing grml CD-ROM at ${MAGENTA}$TARGET_DEV${NORMAL}." ; echo "  $SUCCESS"
   else
-    echo -n "${CRE} ${RED}Accessing grml CD-ROM failed. Could not find $GRML_DIR/$GRML_NAME on ${MAGENTA}$TARGET_DEV${RED}.${NORMAL}"
+    log_failure_msg "Accessing grml CD-ROM failed. Could not find $GRML_DIR/$GRML_NAME on ${MAGENTA}$TARGET_DEV${RED}.${NORMAL}"
     [ -n "$LOOP_SOURCE" ] && /bin/umount $LOOP_SOURCE
     umount $TARGET
     sleep 2
@@ -664,7 +704,7 @@ copy_to()
        fi
       done
       if test -z "$MOUNTED"; then
-        echo -n "${CRE} ${RED}Copying grml CD-ROM failed. ${MAGENTA}$TARGET_DEV_DESC${RED} is not mountable.${NORMAL}"
+        log_failure_msg "Copying grml CD-ROM failed. ${MAGENTA}$TARGET_DEV_DESC${NORMAL} is not mountable."
         sleep 2
         return 1
       fi
@@ -682,7 +722,7 @@ copy_to()
 
   if [ $FOUNDSPACE -lt $SIZE ]
   then
-    echo -n "${CRE} ${RED}Copying grml CD-ROM failed. Not enough free space on ${MAGENTA}${TARGET_DEV_DESC}${RED}. Found: ${MAGENTA}${FOUNDSPACE}k${RED} Need: ${MAGENTA}${SIZE}k${RED} ${NORMAL}"
+    log_failure_msg "Copying grml CD-ROM failed. Not enough free space on ${MAGENTA}${TARGET_DEV_DESC}${NORMAL}. Found: ${MAGENTA}${FOUNDSPACE}k${NORMAL} Need: ${MAGENTA}${SIZE}k${NORMAL}"
     sleep 2
     umount $TARGET
     return 1
@@ -690,7 +730,8 @@ copy_to()
 
   # do the real copy
 
-  echo "${CRE} ${GREEN}Copying grml CD-ROM to ${MAGENTA}$TARGET_DEV_DESC${GREEN}... Please be patient. ${NORMAL}"
+  log_begin_msg "Copying grml CD-ROM to ${TARGET_DEV_DESC}... Please be patient."
+  echo
   if [ -z "$use_cp" -a -x /usr/bin/rsync ]
   then
     # first cp the small files
@@ -699,17 +740,24 @@ copy_to()
     [ -f $TARGET/$GRML_DIR/$GRML_NAME ] && /bin/rm -f $TARGET/$GRML_DIR/$GRML_NAME
     /usr/bin/rsync -a --progress --include="$GRML_DIR/$GRML_NAME" --include="$GRML_DIR/" --exclude="*" $COPY $TARGET # Copy grml to $TARGET
     #/usr/bin/rsync -avP $COPY $TARGET # Copy grml to $TARGET
+    # make sure to support directories from http://grml.org/config/
+    for dir in scripts bootparams config debs ; do
+        if [ -d "/cdrom/$dir" ] ; then
+           log_begin_msg "Customization directory $dir found, copying to $TARGET"
+           cp -a /cdrom/$dir $TARGET/ && echo "$SUCCESS" || echo "$FAILED"
+        fi
+    done
   else
     /bin/cp -a -f $COPY $TARGET # Copy grml to $TARGET
   fi
   if [ $? -ne 0 ]
   then
-    echo -n "${CRE} ${RED}Copying grml CD-ROM failed. ${MAGENTA}$TARGET_DEV_DESC${RED} possibly has not enough space left.${NORMAL}"
+    log_failure_msg "Copying grml CD-ROM failed. ${MAGENTA}$TARGET_DEV_DESC${NORMAL} possibly has not enough space left."
     sleep 2
     return 1
   fi
   # remount r/o
-  /bin/mount -n -o remount,ro $TARGET
+  /bin/mount -n -o remount,ro $TARGET 1>/dev/null 2>&1
   remount_grml
 }
 
@@ -737,32 +785,39 @@ if  test -n "$DO_REMOUNT" -a -n "$FOUND_GRML" ; then
 
   # first copy_to, then boot_from
   if [ -n "$COPYTO" ]; then
-   copy_to $COPYTO && REAL_TARGET="$TARGET"
+     copy_to $COPYTO && REAL_TARGET="$TARGET"
   fi
   if [ -n "$BOOTFROM" ]; then
-    boot_from
-    if [ "$?" -eq "0" ]; then
-      # set new source / target paths
-      REAL_TARGET="$TARGET"
-      SOURCE2="$LOOP_SOURCE"
-      SOURCE="/cdrom2"
-      TARGET="/cdrom3"
+     boot_from
+     if [ "$?" -eq "0" ]; then
+        # set new source / target paths
+        REAL_TARGET="$TARGET"
+        SOURCE2="$LOOP_SOURCE"
+        SOURCE="/cdrom2"
+        TARGET="/cdrom3"
     fi
   fi
 fi
 
 # Final test if everything succeeded.
-if test -n "$FOUND_GRML"
-then
+if test -n "$FOUND_GRML" ; then
 # copy library cache
 cat /GRML/etc/ld.so.cache > /etc/ld.so.cache
 
 UNIONFS=""
-$INSMOD /modules/unionfs.ko 1>/dev/null
-grep -q unionfs /proc/filesystems && UNIONFS=yes
-
-# Enable kernel messages
-echo "6" > /proc/sys/kernel/printk
+if checkbootparam "unionfs" ; then
+   $INSMOD /modules/unionfs.ko 1>/dev/null
+   grep -q unionfs /proc/filesystems && UNIONFS=yes
+   unionfs='unionfs'
+   UNIONFS_FILETYPE='unionfs'
+   AUFS=''
+else
+   $INSMOD /modules/aufs.ko 1>/dev/null
+   grep -q aufs /proc/filesystems && UNIONFS=yes
+   unionfs='unionfs (using aufs)'
+   UNIONFS_FILETYPE='aufs'
+   AUFS='yes'
+fi
 
 # Set paths
 log_begin_msg "Setting paths"
@@ -781,10 +836,9 @@ export PATH
 # From here, we should have all essential commands available.
 hash -r
 
-# Did we remount the source media ?
-if  test -n "$REAL_TARGET";
-then
-   /bin/mount -n --move $REAL_TARGET /cdrom # move it back and go on to normal boot
+# Did we remount the source media?
+if  test -n "$REAL_TARGET"; then
+  /bin/mount -n --move $REAL_TARGET /cdrom # move it back and go on to normal boot
 fi
 
 # Clean up /etc/mtab (and - just in case - make a nice entry for looped ISO)
@@ -801,7 +855,11 @@ FOUNDMEM="$(awk '/MemTotal/{print $2}' /proc/meminfo)"
 TOTALMEM="$(awk 'BEGIN{m=0};/MemFree|Cached/{m+=$2};END{print m}' /proc/meminfo)"
 
 # Be verbose
-log_begin_msg "Total memory found: $FOUNDMEM kB" ; echo "       $SUCCESS"
+if [ -n "$FOUNDMEM" ] ; then
+   log_begin_msg "Total memory found: $FOUNDMEM kB" ; echo "       $SUCCESS"
+else
+   log_failure_msg "Could not fetch memory information." ; echo "     $FAILED"
+fi
 
 # Now we need to use a little intuition for finding a ramdisk size
 # that keeps us from running out of space, but still doesn't crash the
@@ -812,39 +870,55 @@ MINSIZE=20000
 # At least this much memory minus 30% should remain when home and var are full.
 MINLEFT=16000
 # Maximum ramdisk size
-MAXSIZE="$(expr $TOTALMEM - $MINLEFT)"
+[ -n "$TOTALMEM" ] && MAXSIZE="$(/usr/bin/expr $TOTALMEM - $MINLEFT)"
 # Default ramdisk size for ramdisk
-RAMSIZE="$(expr $TOTALMEM / 5)"
+[ -n "$TOTALMEM" ] && RAMSIZE="$(/usr/bin/expr $TOTALMEM / 5)"
 
 # Create additional dynamic ramdisk.
 test -z "$RAMSIZE" -o "$RAMSIZE" -lt "$MINSIZE" && RAMSIZE="$MINSIZE"
 mkdir -p /ramdisk
 # tmpfs/varsize version, can use swap
-RAMSIZE=$(expr $RAMSIZE \* 4)
+RAMSIZE=$(/usr/bin/expr $RAMSIZE \* 4)
 log_begin_msg "Creating /ramdisk (dynamic size=${RAMSIZE}k) on shared memory"
 # We need /bin/mount here for the -o size= option
 /bin/mount -t tmpfs -o "size=${RAMSIZE}k" /ramdisk /ramdisk  && echo "$SUCCESS"
-mkdir -p /ramdisk/tmp /ramdisk/home/grml && chmod 1777 /ramdisk/tmp && chown grml.grml /ramdisk/home/grml && ln -snf /ramdisk/home /home && mv /tmp /tmp.old && ln -s /ramdisk/tmp /tmp && rm -rf /tmp.old
+mkdir -p /ramdisk/tmp /ramdisk/home/grml && chmod 1777 /ramdisk/tmp && chown grml.grml /ramdisk/home/grml && ln -snf /ramdisk/home /home && /bin/mv /tmp /tmp.old && ln -s /ramdisk/tmp /tmp && rm -rf /tmp.old
 
 stage=3
 rundebugshell
 # unionfs
-log_begin_msg "Creating unionfs and symlinks on ramdisk"
+log_begin_msg "Creating $unionfs and symlinks on ramdisk"
 mkdir -p /UNIONFS
-if test -n "$UNIONFS" && /bin/mount -t unionfs -o noatime${SECURE},dirs=/ramdisk=rw:/GRML=ro /UNIONFS /UNIONFS; then
+if test -n "$UNIONFS" && /bin/mount -t $UNIONFS_FILETYPE -o noatime${SECURE},dirs=/ramdisk=rw:/GRML=ro /UNIONFS /UNIONFS ; then
+ # check architecture
+ if [ -f /GRML/lib/ld-linux.so.2 ] ; then
+   LDLINUX=/GRML/lib/ld-linux.so.2
+   GRMLLIB=/GRML/lib
+ elif [ -f /GRML/lib64/ld-linux-x86-64.so.2 ] ; then
+   LDLINUX=/GRML/lib64/ld-linux-x86-64.so.2
+   EMUL='emul'
+   LIB64='lib64'
+   GRMLLIB=/GRML/lib64
+ fi
  # We now have unionfs, copy some data from the initial ramdisk first
  cp -a /etc/fstab /etc/auto.mnt /etc/filesystems /etc/mtab /UNIONFS/etc/
- for i in bin boot etc sbin var lib opt root usr; do # Move directories to unionfs
+ # disable resolvconf on the terminalserver client
+ if [ -n "$NFS" ] ; then
+    rm /UNIONFS/etc/resolv.conf
+    cp -a /etc/resolv.conf /UNIONFS/etc
+    echo REPORT_ABSENT_SYMLINK=no >> /UNIONFS/etc/default/resolvconf
+ fi
+ for i in bin boot etc sbin var opt root usr $EMUL $LIB64 lib ; do # Move directories to unionfs
   if test -d /$i; then
-   mv /$i /$i.old && \
-   /GRML/lib/ld-linux.so.2 --library-path /GRML/lib /GRML/bin/ln -snf /UNIONFS/$i /$i && \
+   /bin/mv /$i /$i.old && \
+   # /GRML/lib/ld-linux.so.2 --library-path /GRML/lib /GRML/bin/ln -snf /UNIONFS/$i /$i && \
+   $LDLINUX --library-path $GRMLLIB /GRML/bin/ln -snf /UNIONFS/$i /$i 1>/dev/null 2>/dev/null
    rm -rf /$i.old
   else
    ln -snf /UNIONFS/$i /$i
   fi
  done
- #echo "${GREEN}done${NORMAL}"
- echo "                 $SUCCESS"
+ [ -n "$AUFS" ] && echo "    $SUCCESS" || echo "                 $SUCCESS"
  log_begin_msg "Merging read-only system with read-writeable /ramdisk."
  for i in $(cd /UNIONFS; echo *); do # Create links for new stuff on /UNIONFS
    test "$i" = "home" -o "$i" = "tmp" && continue
@@ -854,8 +928,10 @@ else
  echo ""
  log_failure_msg "ERROR: CANNOT UNITE READ-ONLY MEDIA AND INITIAL RAMDISK!"
  echo "$FAILED"
- NOUNIONFS="yes"
- /GRML/sbin/halt -f -n
+ sleep 2
+ echo "Can not continue booting, dropping you to a busybox shell."
+ stage=4
+ rundebugshell
 fi
 
 chown grml.grml /home/grml
@@ -893,18 +969,18 @@ echo "/sbin/modprobe" > /proc/sys/kernel/modprobe
 # Change root device from /dev/fd0 to /dev/ram0
 echo "0x100" > /proc/sys/kernel/real-root-dev
 
-umount /sys # (remount in grml-autoconfig)
+/bin/umount /sys # (remount in grml-autoconfig)
 
 stage=4
 rundebugshell
 # Give control to the init process.
-log_begin_msg "Starting init process."
+log_begin_msg "Starting init process. "
 [ -r /mountit ] && rm -f /mountit
 rm -f /linuxrc
 exit 0
 
 else
echo "${CRE}${RED}Can't find grml filesystem, sorry.${NORMAL}"
log_failure_msg "Error: Can't find grml filesystem, sorry."
  echo "
 Are you booting via USB or firewire?
 ====================================